# v5.3

Caching has been vastly improved in this release due to a new sqlite3-backed persistent `cache.db`. There have also been some improvements to `[f1]` help pages

## Breaking Changes

None

## Deprecation Warnings

Please read out [compatibility commitment](https://murex.rocks/compatibility.html) to understand how features are deprecated.

* the `?` pipe will be deprecated to make way for a the ternary operator. You can achieve the same result with `<err> <!out>`, eg `command <err> <!out> parameters... | next-command ...`
  
## Features

* persistent cache added using sqlite3 backend. This cache is optional however it is enabled by default. You can disable it by placing the following into your `.murex_profile`:
  ```
  config set shell cache.db-enabled false
  ```

* new `autocomplete` directive for `[f1]` previews: `DynamicPreview`

* dynamic previews added for `git` and `aws`

## Bug Fixes

* `export` now supports whitespace like an expression ([issue #679](https://github.com/lmorg/murex/issues/679))

* bugfix: structures in variables would sometimes output base64 encoded values when converting those structures to arrays ([issue #768](https://github.com/lmorg/murex/issues/768))

* some `ReadArrayWithType()` calls weren't handling the returned error (if there were an error). They're now all surfacing errors correctly

* whats new message moved to shell `Start()`
  
## Special Thanks

Special thank you to everyone in the community for raising bug reports and design discussions.

You rock!

<hr>

Published: 08.12.2023 at 12:32

## See Also

* [Contributing](../Murex/CONTRIBUTING.md):
  Guide to contributing to Murex
* [`autocomplete`](../commands/autocomplete.md):
  Set definitions for tab-completion in the command line
* [`config`](../commands/config.md):
  Query or define Murex runtime settings
* [`export`](../commands/export.md):
  Define an environmental variable and set it's value

<hr/>

This document was generated from [gen/changelog/v5.3_doc.yaml](https://github.com/lmorg/murex/blob/master/gen/changelog/v5.3_doc.yaml).